SystemOrganization addCategory: #'GT-Playground'!

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'AndreiChis 9/8/2014 22:56'!
acceptAction: anAction 
	"Be compatible with edit:label:accept:.
	Not the best place for this method.
	Interim situation to move things forward..."
	self flag: #TODO.
	self model ifNotNil: [:aModel | aModel acceptAction: anAction].! !

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'AndreiChis 9/8/2014 22:55'!
acceptContents: aString 
	"Be compatible with edit:label:accept:.
	Not the best place for this method.
	Interim situation to move things forward..."
	self flag: #TODO.
	self model ifNotNil: [:aModel | aModel acceptContents: aString].

	! !

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'DenisKudryashov 4/13/2016 15:24'!
model: anObject
	model := anObject! !

!GLMBrickThemer methodsFor: '*GT-Playground' stamp: 'AliakseiSyrel 3/30/2015 12:22'!
bindingThemer

	^ self registerModule: GTPlayBindingThemer new
		to: GLMActionBrickThemer new! !

!GLMActionBrickDarkThemer methodsFor: '*GT-Playground' stamp: 'AliakseiSyrel 3/27/2015 13:33'!
bindingThemer

	^ self registerModule: GTPlayBindingDarkThemer new! !

!Duration methodsFor: '*GT-Playground' stamp: 'TudorGirba 3/16/2015 07:42'!
gtPlaygroundHumanReadableString
	self < 1 minute ifTrue: [ ^ 'just now' ].
	self < 2 minutes ifTrue: [ ^ '1 minute ago' ].
	self < 1 hour ifTrue: [ ^ self minutes asString , ' minutes ago' ].
	self < 1 day ifTrue: [ ^ self hours asString , ' hours ago' ].
	self < 1 year ifTrue: [ ^ self days asString , ' days ago' ].
	^ self printString! !

!GLMActionBrickThemer methodsFor: '*GT-Playground' stamp: 'AliakseiSyrel 3/27/2015 12:23'!
bindingThemer

	^ self registerModule: GTPlayBindingThemer new! !

GLMEditableLabelBrick subclass: #GTPlaygroundEditableTabLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlaygroundEditableTabLabel methodsFor: 'initialization' stamp: 'AliakseiSyrel 3/30/2015 13:00'!
defaultPadding

	^ 5! !

!GTPlaygroundEditableTabLabel methodsFor: 'initialization' stamp: 'AliakseiSyrel 3/30/2015 13:01'!
initialize
	super initialize.
	
	self
		hSpaceFill;
		with: [ :label | label when: #onAccepted do: [ self announce: #accepted event: label text ] ];
		cancelOnEscape;
		cancelOnFocusLost;
		with: [ :b | b margin: { b themer focusedBorderWidth . 0 } ];
		with: [ :b | b editBrick
			hShrinkWrap;
			rubricBackgroundColor: b themer rubricBackgroundColor;
			margins: (self defaultPadding@0 corner: self defaultPadding@0) ];
		with: [ :b | b maxWidth: [ b approximateWidth + b owner hPadding] ];
		with: [ :b | b labelBrick margin: { 0 . self defaultPadding + 2. 0 . self defaultPadding } ];
		with: [ :b | b layout widthDependency: [ b owner ] ];
		with: [ :b | b editBrick layout widthDependency: [ b ] ];
		yourself ! !

GLMCompositePresentation subclass: #GTPlayground
	instanceVariableNames: ''
	classVariableNames: 'GTPlaygroundEnabledStatus PreferredExtent RememberPreferredExtent'
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayground commentStamp: 'TudorGirba 10/22/2014 07:37' prior: 0!
Playground is the correspondent of a classic Smalltalk Workspace. The problem with the name Workspace is that it implies that work should be carried out in this space, while this is not a best practice. Playground describes better the intention of providing a place in which we can quickly play with some code.

The model behind a Playground instance is a PlayPage object.

!!!!Use cases
The Playground can be used in two ways

# As a place to construct and try out code snippets.
# as an entry point into an inspection process.

In both cases, the ability of diving into objects to the right is an important feature.

!!!!Running
[ [ [ 
	self open.
 ] ] ]!

!GTPlayground class methodsFor: 'menu' stamp: 'AndreiChis 9/8/2015 15:11'!
contextMenuBasicActionsFor: aPlayground
	<playgroundContextMenu>
	
	^ aPlayground codePresentation defaultSelectionActions ! !

!GTPlayground class methodsFor: 'compatibility-tools' stamp: 'StefanReichhart 3/20/2015 22:04'!
edit: aString label: aLabel

"Open a new playground with the given contents"
"Compatibility with the original Workspace"
"#edit: aText label: labelString accept: anAction"
"	^(Smalltalk tools workspace openLabel: labelString)
		acceptContents:  aText;
		acceptAction: anAction;
		yourself."

"Open an editor on the given string/text"
	| page |
	"self halt"

	page := GTPlayPage new
		saveContent: aString;
		title: aLabel;
		yourself.
		
	self flag: #TODO. "We need to put an equivalent to the acceptAction thing."
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'examples' stamp: 'AndreiChis 1/30/2015 12:28'!
examplePlaygroundWithBindings
	| playground wsBindings |
	wsBindings := Dictionary newFrom: { #number-> 1 }.
	playground := Smalltalk tools workspace
		openContents: 'number + 1'.
	playground
		setBindings: wsBindings.! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
extentSettingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #GTPlaygroundPreferredWidth)
		target: self;
		parent: #gt;
		getSelector: #preferredWidth;
		setSelector: #preferredWidth:; 
		label: 'Playground width';
		description: 'The preferred width of new Playground windows'.
	(aBuilder setting: #GTPlaygroundPreferredHeight)
		target: self;
		parent: #gt;
		getSelector: #preferredHeight;
		setSelector: #preferredHeight:; 
		label: 'Playground height';
		description: 'The preferred height of new Playground windows'.
	(aBuilder setting: #GTPlaygroundRememberPreferredExtent)
		target: self;
		parent: #gt;
		getSelector: #rememberPreferredExtent;
		setSelector: #rememberPreferredExtent:; 
		label: 'Remember extent of Playground';
		description: 'Enable or disable remembering of the extent of Playground windows on resize. When the preference is true, resizing a Playground window will affect the preferred width and height of future Playground windows'.
	


! !

!GTPlayground class methodsFor: 'settings' stamp: 'AndreiChis 8/29/2014 00:39'!
isGTPlaygroundEnabled

	^ GTPlaygroundEnabledStatus ifNil: [ GTPlaygroundEnabledStatus := Smalltalk tools workspace = self ]! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 3/25/2015 22:41'!
open
	"self open"
	| page |
	page := GTPlayPage new.
	^ self openOn: page! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'AndreiChis 4/1/2015 13:12'!
openContents: aString
	"Open a new playground with the given contents. aString has to be Smalltalk code. The style is applied"
	

	| page |
	
	page := GTPlayPage new
		saveContent: aString;
		yourself.
	^ self new 
		openOn: page;
		yourself! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 3/25/2015 22:41'!
openContents: aString label: aLabel
	"Open a new playground with the given contents"

	| page |

	page := GTPlayPage new
		saveContent: aString;
		title: aLabel;
		yourself.
	^ self openOn: page! !

!GTPlayground class methodsFor: 'compatibility-tools' stamp: 'TudorGirba 3/25/2015 22:41'!
openLabel: aLabel
	| page |

	page := GTPlayPage new
		title: aLabel;
		yourself.
	^ self openOn: page! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 22:18'!
preferredExtent
	^ PreferredExtent ifNil: [ PreferredExtent := 600@400 ]! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 22:16'!
preferredExtent: aPoint
	PreferredExtent := aPoint! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:02'!
preferredHeight
	^ self preferredExtent y! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:05'!
preferredHeight: aHeight
	self preferredExtent setX: self preferredExtent x setY: aHeight! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:02'!
preferredWidth
	^ self preferredExtent x! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:04'!
preferredWidth: aWidth
	self preferredExtent setX: aWidth setY: self preferredExtent y! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'AndreiChis 8/28/2014 21:33'!
register

	self registerToolsOn: Smalltalk tools! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'TudorGirba 2/9/2014 01:10'!
registerToolsOn: registry
	"Add ourselves to registry. See [Smalltalk tools]"
	"self registerToolsOn: Smalltalk tools" 
	registry register: self as: #workspace
! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 22:55'!
rememberPreferredExtent
	^ RememberPreferredExtent ifNil: [ RememberPreferredExtent := true ]! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 23:02'!
rememberPreferredExtent: aBoolean
	^ RememberPreferredExtent := aBoolean! !

!GTPlayground class methodsFor: 'settings' stamp: 'AndreiChis 8/28/2014 21:33'!
setGTPlaygroundEnabledStatus: aBoolean
	| oldStatus |
	
	oldStatus := self isGTPlaygroundEnabled.
	GTPlaygroundEnabledStatus := aBoolean.
	oldStatus ~= GTPlaygroundEnabledStatus ifTrue: [ 
		GTPlaygroundEnabledStatus 
			ifTrue: [ self register ]
			ifFalse: [ Workspace registerToolsOn: Smalltalk tools ] ]
	
	! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 3/25/2015 22:54'!
setPreferredExtentIfWanted: anExtent
	self rememberPreferredExtent ifTrue: [ 
		self preferredExtent: anExtent ]! !

!GTPlayground class methodsFor: 'settings' stamp: 'StephaneDucasse 11/3/2016 21:14'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #GTPlaygroundStatus)
		target: self;
		parent: #gt;
		getSelector: #isGTPlaygroundEnabled;
		setSelector: #setGTPlaygroundEnabledStatus:; 
		label: 'GTPlayground';
		description: 'Enable or disable the GTPlayground.'.
	(aBuilder setting: #cacheDirectory)
		parent: #gt;
		type: #Directory;
		target: GTPlayBook;
		description: 'The path to the local Playground cache that stores all Playground scripts in ph files';
		label: 'Local Playground cache directory'.
	(aBuilder setting: #stashDirectory)
		parent: #gt;
		type: #Directory;
		target: GTPlayBook;
		description: 'The path to the local Playground stash that stores all named Playground scripts in ph files';
		label: 'Local Playground stash directory'! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'DenisKudryashov 11/4/2016 15:47'!
taskbarIconName
	"Answer the icon for the receiver in a task bar."

	^ #workspaceIcon! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 3/15/2015 21:49'!
title
	^ 'Playground'! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/8/2014 23:02'!
acceptAction: anAction
	"acceptAction := anAction."! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/30/2014 20:46'!
acceptContents: aString

	^ (self entity acceptContents: aString)
		ifTrue: [  
			self update.
			true]! !

!GTPlayground methodsFor: 'actions' stamp: 'AndreiChis 7/24/2015 10:49'!
actOnBrowserClosing: ann

	"This is a hack for the moment.
	We need a better mechanism from Glamour to help 
	us keep the model in sync"
	self entity
		saveContent: self first panes first presentations first text.
	GTPlayBook instance addPageIfInteresting: self entity! !

!GTPlayground methodsFor: 'building' stamp: 'StephaneDucasse 10/12/2016 22:34'!
codeIn: a
	^ (self codePresentationIn: a)
		title: [ :page | 
			GTPlaygroundEditableTabLabel new
				text: page title;
				when: #accepted
					do: [ :text | page setTitleAndEnsureInStash: text asString ];
				yourself ];
		format: [ :page | page content ];
		act: [ :text :page | 
				text selectionInterval: (1 to: text text size).
				text highlightEvaluateAndDo: [ :result | text selection: result ] ]
			icon: GLMUIThemeExtraIcons glamorousGo
			on: $G
			entitled: 'Do it all and go';
		act: [ :text :page | page publish ]
			iconName: #glamorousSaveToUrl
			entitled: 'Remote publish';
		addAction:
			(GLMPopupAction new
				action: [ :text :page :popup | 
					GTPlaygroundBindingsList new
						on: self currentBindingsSorted;
						when: #bindingRemoved
							do: [ :binding | self removeBinding: binding ];
						when: #inspect do: [ :binding | binding value inspect ];
						when: #go do: [ :binding | text selection: binding value ];
						yourself ];
				iconName: #glamorousTable;
				title: 'Bindings';
				yourself);
		addAction:
			(GLMPopupAction new
				action: [ :text :page :popup | 
					GTPlaygroundPlayPagesList new
						on: GTPlayBook instance;
						when: #pageAccepted
							do: [ :playPage | 
							text entity saveContent: playPage content.
							text update ];
						yourself ];
				iconName: #glamorousMore;
				title: 'Play pages';
				yourself);
		dynamicActionsOnSelection: [ self contextMenuActions ];
		onChangeOfPort: #text
			act: [ :text :page | 
			page saveContent: text text.
			text clearUserEdits ]! !

!GTPlayground methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 9/8/2015 14:50'!
codePresentation

	^ self inspectorPresentation firstPresentation! !

!GTPlayground methodsFor: 'building' stamp: 'AndreiChis 10/23/2015 17:16'!
codePresentationIn: composite

	^ composite pharoScript! !

!GTPlayground methodsFor: 'building' stamp: 'AndreiChis 6/25/2016 14:05'!
compose
	self title: self defaultPlaygroundTitle.
	self act: [:b | b update] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Update'.
	self act: [:b | 
		HelpBrowser open selectTopicSatisfying: [:each |
			each owner notNil and:  [
			(each owner key = GTPlaygroundHelp key) and: [
				each title = 'Overview' ] ] ] ] 
		icon: GLMUIThemeExtraIcons glamorousHelp 
		entitled: 'Help'.
	self custom:
			(GTInspector new
				noTitle; 
				noActions;
				showFirst: [ :composite |
					self codeIn: composite ];
				yourself);
		when: GLMBrowserClosing do: [ :ann |
			self actOnBrowserClosing: ann ]! !

!GTPlayground methodsFor: 'building actions' stamp: 'AutoDeprecationRefactoring 7/4/2016 21:40'!
contextMenuActions
	^ (Pragma
		allNamed: self contextMenuPragma
		from: self class class
		to: Object class)
		flatCollect:
			[ :eachPragma | self class perform: eachPragma methodSelector with: self ]! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/8/2015 14:44'!
contextMenuPragma

	^ #playgroundContextMenu! !

!GTPlayground methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 9/8/2015 14:50'!
currentBindings 

	^ self codePresentation currentBindings! !

!GTPlayground methodsFor: 'accessing-dynamic' stamp: 'AliakseiSyrel 3/27/2015 12:08'!
currentBindingsSorted

	^ self currentBindings associations asSortedCollection: [ :first :second | first key < second key ]! !

!GTPlayground methodsFor: 'accessing-defaults' stamp: 'AndreiChis 3/25/2015 15:41'!
defaultPlaygroundTitle
	^ 'Playground'! !

!GTPlayground methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 1/30/2015 11:35'!
inspectorPresentation

	^ self presentations first ! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 1/9/2015 11:17'!
label: aString
	"Set the window label to the given string"
	self title: aString.
	self update! !

!GTPlayground methodsFor: 'scripting opening' stamp: 'TudorGirba 4/3/2015 12:52'!
openOn: aPage
	| window |
	window := super openOn: aPage.
	window extent: self class preferredExtent.
	window when: WindowResizing do: [ 
		(window isMinimized or: [ window isMaximized ]) ifFalse: [ 
			"we only wnat to react to real resizing,
			not to minization or maximization"
			self class setPreferredExtentIfWanted: window extent ] ].
	^ window! !

!GTPlayground methodsFor: 'accessing-dynamic' stamp: 'AliakseiSyrel 3/27/2015 12:19'!
removeBinding: anAssociation

	|bindings|
	bindings := self currentBindings copy.
	bindings removeKey: anAssociation key ifAbsent: [ ].
	self setBindings: bindings.! !

!GTPlayground methodsFor: 'actions' stamp: 'AndreiChis 3/19/2015 17:52'!
resetBindings

	^ self inspectorPresentation firstPresentation resetBindings! !

!GTPlayground methodsFor: 'actions' stamp: 'AndreiChis 1/30/2015 11:42'!
setBindings: aDictionary

	self inspectorPresentation firstPresentation 
		variableBindings: [ aDictionary associations ];
		updateVariableBindings! !

!GLMBrickDarkThemer methodsFor: '*GT-Playground' stamp: 'AliakseiSyrel 3/30/2015 12:22'!
bindingThemer

	^ self registerModule: GTPlayBindingDarkThemer new
		to: GLMActionBrickDarkThemer new! !

GLMBrickThemerModule subclass: #GTPlayBindingThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTPlayBindingThemer subclass: #GTPlayBindingDarkThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayBindingDarkThemer methodsFor: 'rows' stamp: 'AliakseiSyrel 3/27/2015 13:37'!
selectedColor

	^ Color veryVeryDarkGray alpha: 0.1! !

!GTPlayBindingThemer methodsFor: 'rows' stamp: 'AliakseiSyrel 3/27/2015 12:49'!
borderColor

	^ self themer popupThemer borderColor! !

!GTPlayBindingThemer methodsFor: 'rows' stamp: 'AliakseiSyrel 3/27/2015 12:48'!
borderWidth

	^ 1! !

!GTPlayBindingThemer methodsFor: 'empty-text' stamp: 'AliakseiSyrel 3/27/2015 13:00'!
emptyTextColor

	^ self themer textLightColor! !

!GTPlayBindingThemer methodsFor: 'empty-text' stamp: 'AliakseiSyrel 3/27/2015 12:24'!
emptyTextFontSize

	^ 13! !

!GTPlayBindingThemer methodsFor: 'empty-text' stamp: 'AliakseiSyrel 3/27/2015 12:26'!
emptyTextPadding

	^ 15! !

!GTPlayBindingThemer methodsFor: 'icons' stamp: 'AliakseiSyrel 3/30/2015 13:25'!
goIcon

	^ GLMUIThemeExtraIcons glamorousGo! !

!GTPlayBindingThemer methodsFor: 'icons' stamp: 'AliakseiSyrel 3/30/2015 13:12'!
inspectIcon

	^ GLMUIThemeExtraIcons glamorousInspect! !

!GTPlayBindingThemer methodsFor: 'rows' stamp: 'AliakseiSyrel 3/27/2015 12:50'!
padding

	^ 5! !

!GTPlayBindingThemer methodsFor: 'icons' stamp: 'AliakseiSyrel 3/27/2015 12:24'!
removeIcon

	^ GLMUIThemeExtraIcons glamorousRemove! !

!GTPlayBindingThemer methodsFor: 'rows' stamp: 'AliakseiSyrel 3/27/2015 13:32'!
selectedColor

	^ Color veryVeryLightGray alpha: 0.5! !

GLMFallbackScrollListBrick subclass: #GTPlaygroundBindingsList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlaygroundBindingsList methodsFor: 'actions' stamp: 'AliakseiSyrel 2/26/2016 23:42'!
hideActionsOf: aRowBrick
	aRowBrick subbricks select: [ :each | each isKindOf: GLMHintableActionButtonBrick ] thenDo: [ :each | each visible: false ]! !

!GTPlaygroundBindingsList methodsFor: 'initialization' stamp: 'AliakseiSyrel 3/30/2015 13:22'!
initialize
	super initialize.
	
	self
		emptyBrick: self newEmptyText;
		maxHeight: 300;
		height: [ :b | b band height ];
		width: 300! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/26/2016 23:50'!
newActionButton
	|margin padding|
	margin := self themer bindingThemer padding + self themer bindingThemer borderWidth.
	padding := (margin / 2) rounded.
	
	^ GLMHintableActionButtonBrick new
		padding: padding;
		visible: false;
		margin: {0 . padding};
		marginRight: margin;
		hShrinkWrap;
		vAlign: #center;
		pressedColor: self themer buttonPressedColor! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 3/30/2015 12:27'!
newBindingLabel

	^ GLMLabelBrick new
		hSpaceFill: 50;
		vShrinkWrap;
		textPosition: #leftCenter;
		vAlign: #center;
		padding: { 0 . self themer bindingThemer padding }! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/26/2016 23:43'!
newBindingRow: anAssociation in: aCollection

	^ self newRow
		borderWidth: { 0 . 0 . aCollection last == anAssociation ifTrue: [ 0 ] ifFalse: [ self themer bindingThemer borderWidth ] . 0 };
		addAllBricks: {
			self newBindingLabel
				textColor: self themer textLightColor;
				text: anAssociation key.
			self newBindingLabel
				text: anAssociation value asString.
			self newInspectButtonFor: anAssociation.
			self newGoButtonFor: anAssociation.
			self newRemoveButtonFor: anAssociation };
		with: [ :aRow | aRow 	
			when: #onMouseHover do: [ self showActionsOf: aRow ];
			when: #onMouseUnhover do: [ self hideActionsOf: aRow ] ];
		yourself! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 3/30/2015 12:26'!
newEmptyText

	^ GLMLabelBrick new
			text: 'No bindings';
			hSpaceFill;
			textPosition: #center;
			padding: self themer bindingThemer emptyTextPadding;
			textColor: self themer bindingThemer emptyTextColor;
			fontSize: self themer bindingThemer emptyTextFontSize;
			yourself! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 3/30/2015 13:24'!
newGoButtonFor: anAssociation

	^ self newActionButton
		hintTitle: 'Go';
		hintText: 'open new pane to the right';
		icon: self themer bindingThemer goIcon;
		action: [ : b | self remove. self announce: #go event: anAssociation. ]! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 3/30/2015 13:19'!
newInspectButtonFor: anAssociation

	^ self newActionButton
		hintTitle: 'Inspect';
		hintText: 'will open inspector window';
		icon: self themer bindingThemer inspectIcon;
		action: [ : b | self remove. self announce: #inspect event: anAssociation. ]! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 3/30/2015 13:10'!
newRemoveButtonFor: anAssociation

	^ self newActionButton
		beError;
		hintTitle: 'Remove binding';
		hintText: 'will unassign variable';
		icon: self themer bindingThemer removeIcon;
		action: [ : b |
			b owner disable.
			GLMAnimation swipeLeft
				onCompleted: [
					self announce: #bindingRemoved event: anAssociation.
					self model origin remove: anAssociation.
					self invalidate ];
				animate: b owner ]! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 3/30/2015 12:30'!
newRow

	^ GLMInteractableBrick new
		enable;
		selectedColor: self themer bindingThemer selectedColor;
		vShrinkWrap;
		hSpaceFill;
		padding: { self themer bindingThemer padding . 0 . self themer bindingThemer padding + self themer bindingThemer borderWidth };
		borderColor: self themer bindingThemer borderColor! !

!GTPlaygroundBindingsList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 3/30/2015 12:35'!
on: aBindingsCollection
	|model|
	model := GLMBrickListModel new
		on: aBindingsCollection.
	model
		morphAtLogic: [ :index | self newBindingRow: (model origin at: index) in: model origin ].
	self model: model! !

!GTPlaygroundBindingsList methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/30/2015 13:23'!
onThemerChanged
	super onThemerChanged.
	
	self doLayoutForce! !

!GTPlaygroundBindingsList methodsFor: 'actions' stamp: 'AliakseiSyrel 3/30/2015 13:19'!
remove

	(self ownerThatIsA:  GLMFoundationBrick)
		ifNotNil: [ :o | o delete ]! !

!GTPlaygroundBindingsList methodsFor: 'actions' stamp: 'AliakseiSyrel 2/26/2016 23:42'!
showActionsOf: aRowBrick
	aRowBrick subbricks select: [ :each | each isKindOf: GLMHintableActionButtonBrick ] thenDo: [ :each | each visible: true ]! !

GLMFallbackScrollListBrick subclass: #GTPlaygroundPlayPagesList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlaygroundPlayPagesList methodsFor: 'actions' stamp: 'AliakseiSyrel 2/26/2016 23:41'!
hideActionsOf: aRowBrick
	aRowBrick subbricks select: [ :each | each isKindOf: GLMHintableActionButtonBrick ] thenDo: [ :each | each visible: false ]! !

!GTPlaygroundPlayPagesList methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/26/2016 23:12'!
initialize
	super initialize.
	
	self
		emptyBrick: self newEmptyText;
		maxHeight: 350;
		height: [ :b | b band height ];
		width: 250! !

!GTPlaygroundPlayPagesList methodsFor: 'instance creation' stamp: 'StephaneDucasse 10/12/2016 18:27'!
newAcceptButtonFor: aPlayPage
	^ self newActionButton
		hintTitle: 'Accept';
		hintText: 'load saved page into playground';
		icon: (self iconNamed: #glamorousAccept);
		action: [ :b | 
			self remove.
			self announce: #pageAccepted event: aPlayPage ]! !

!GTPlaygroundPlayPagesList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/26/2016 23:50'!
newActionButton
	|margin padding|
	margin := self themer bindingThemer padding + self themer bindingThemer borderWidth.
	padding := (margin / 2) rounded.
	
	^ GLMHintableActionButtonBrick new
		padding: padding;
		visible: false;
		margin: { 0 . padding };
		hShrinkWrap;
		vAlign: #center;
		pressedColor: self themer buttonPressedColor! !

!GTPlaygroundPlayPagesList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/26/2016 22:57'!
newEmptyText

	^ GLMLabelBrick new
			text: 'No saved pages';
			hSpaceFill;
			textPosition: #center;
			padding: self themer bindingThemer emptyTextPadding;
			textColor: self themer bindingThemer emptyTextColor;
			fontSize: self themer bindingThemer emptyTextFontSize;
			yourself! !

!GTPlaygroundPlayPagesList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/26/2016 23:25'!
newPageLabel

	^ GLMLabelBrick new
		hSpaceFill;
		vShrinkWrap;
		textPosition: #leftCenter;
		vAlign: #center;
		padding: { 0 . self themer bindingThemer padding }! !

!GTPlaygroundPlayPagesList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/26/2016 23:41'!
newPageRow: playPage in: aGTPlayBook

	^ self newRow
		addBrickBack: (self newPageLabel
			textColor: self themer textColor;
			text: (playPage content asString contractTo: 50));
		addBrickBack: (self newAcceptButtonFor: playPage);
		when: #onDoubleClicked do: [ self remove. self announce: #pageAccepted event: playPage ];
		with: [ :aRow | aRow 	
			when: #onMouseHover do: [ self showActionsOf: aRow ];
			when: #onMouseUnhover do: [ self hideActionsOf: aRow ] ];
		yourself! !

!GTPlaygroundPlayPagesList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/26/2016 23:49'!
newRow
	^ GLMInteractableBrick new
		enable;
		enableDoubleClick;
		selectedColor: self themer bindingThemer selectedColor;
		vShrinkWrap;
		hSpaceFill;
		padding: self themer bindingThemer padding;
		paddingRight: 0! !

!GTPlaygroundPlayPagesList methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/26/2016 22:58'!
on: aGTPlayBook
	|model|
	model := GLMBrickListModel new
		on: aGTPlayBook pages.
	model
		morphAtLogic: [ :index | self newPageRow: (model origin at: index) in: aGTPlayBook ].
	self model: model! !

!GTPlaygroundPlayPagesList methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 2/26/2016 23:03'!
onThemerChanged
	super onThemerChanged.
	
	self doLayoutForce! !

!GTPlaygroundPlayPagesList methodsFor: 'actions' stamp: 'AliakseiSyrel 2/26/2016 22:49'!
remove

	(self ownerThatIsA:  GLMFoundationBrick)
		ifNotNil: [ :o | o delete ]! !

!GTPlaygroundPlayPagesList methodsFor: 'actions' stamp: 'AliakseiSyrel 2/26/2016 23:41'!
showActionsOf: aRowBrick
	aRowBrick subbricks select: [ :each | each isKindOf: GLMHintableActionButtonBrick ] thenDo: [ :each | each visible: true ]! !

!SequenceableCollection methodsFor: '*GT-Playground' stamp: 'StefanReichhart 3/21/2015 09:52'!
takeFirst: anInteger
	^ self first: (self size min: anInteger)! !

!RxMatcher methodsFor: '*GT-Playground' stamp: 'StefanReichhart 3/21/2015 09:52'!
matchesIn: aString subexpressionsDo: aBlock
	self matchesOnStream: aString readStream subexpressionsDo: aBlock! !

!RxMatcher methodsFor: '*GT-Playground' stamp: 'StefanReichhart 3/21/2015 09:51'!
matchesOnStream: aStream subexpressionsDo: aBlock
	| subexpressions |
	[ self searchStream: aStream ] whileTrue: [ 
		subexpressions := ((1 to: self subexpressionCount) collect: [ :each | (self subexpression: each) ]).
		aBlock value: subexpressions first value: subexpressions allButFirst ]! !

CustomHelp subclass: #GTPlaygroundHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlaygroundHelp commentStamp: 'TudorGirba 1/21/2016 16:51' prior: 0!
A utility class containing the help for the GT Playground.!

!GTPlaygroundHelp class methodsFor: 'accessing' stamp: 'TudorGirba 1/21/2016 17:16'!
bookName 
	^'GT Playground'! !

!GTPlaygroundHelp class methodsFor: 'accessing' stamp: 'TudorGirba 1/21/2016 16:51'!
key
	^ self name! !

!GTPlaygroundHelp class methodsFor: 'documentation' stamp: 'TudorGirba 1/21/2016 17:17'!
overview
	^ HelpTopic 
		title: 'Overview'
		contents: 
'GT Playground provides an interface for scripting and live programming. It is part of Pharo and was developed as part of the Glamorous Toolkit project (http://gt.moosetechnology.org).'! !

!GTPlaygroundHelp class methodsFor: 'accessing' stamp: 'TudorGirba 1/21/2016 17:16'!
pages
	^#(overview )! !

Object subclass: #GTPlayBook
	instanceVariableNames: 'pages pagesLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTPlayBook class
	instanceVariableNames: 'instance cacheDirectory stashDirectory'!

!GTPlayBook commentStamp: 'TudorGirba 10/22/2014 07:51' prior: 0!
This class holds the pages that are loaded in the image.

At class initialization time, it loads pages from the cacheDirectory and then maintains the pages in memory.!

GTPlayBook class
	instanceVariableNames: 'instance cacheDirectory stashDirectory'!

!GTPlayBook class methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 22:49'!
cacheDirectory
	" lazy initialize the cache and always ensure its existence - especially while the image is running "
	cacheDirectory ifNil: [ cacheDirectory := self defaultCacheDirectory ].
	^ cacheDirectory ensureCreateDirectory! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 23:04'!
cacheDirectory: aStringOrFileReference

	cacheDirectory := self 
							ensureDirectory: aStringOrFileReference 
							distinctFrom: self defaultCacheDirectory! !

!GTPlayBook class methodsFor: 'private' stamp: 'AndreiChis 3/25/2015 16:19'!
cleanUp
	
	self reset! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'TudorGirba 4/11/2015 14:18'!
customDirectory: aFileReference 
	"this is here for preserving backward compatibility with 
	older settings that relied on customDirectory instead
	of cacheDirectory"
	self cacheDirectory: aFileReference! !

!GTPlayBook class methodsFor: 'accessing-defaults' stamp: 'EstebanLorenzano 6/23/2016 16:56'!
defaultCacheDirectory
	^ (FileLocator localDirectory / 'play-cache') asFileReference! !

!GTPlayBook class methodsFor: 'accessing-defaults' stamp: 'EstebanLorenzano 6/23/2016 16:56'!
defaultStashDirectory
	^ (FileLocator localDirectory / 'play-stash') asFileReference! !

!GTPlayBook class methodsFor: 'private' stamp: 'TudorGirba 4/7/2015 22:55'!
ensureDirectory: aStringOrFileReference distinctFrom: aDefaultDirectory
		" Ensure aStringOrFileReference is either nil or a valid file-reference object distinct from the default one.
	  Do not create any directory on disk yet - the first access to any directory will handle that.
	  #asFileReference and #absolutePath may raise anError!! "
	| fileReference |

	^ [ 
		fileReference := aStringOrFileReference asFileReference.
		^ fileReference absolutePath = aDefaultDirectory absolutePath
			ifTrue: [ nil ]
			ifFalse: [ fileReference ]
			
		" Background: The behavior of the default directory is being relative to the image. Therefore the default file-reference is relative to the image. If the image is moved/copied around the file-reference will stay relative to the image. We assume this is the expected behavior for the default directory. Therefore we prevent the user from setting that value as an absolute file-reference, since an absolute file-reference would behave differently when an image is moved/copied around. "	
		]
			on: Error
			do: [ nil ]! !

!GTPlayBook class methodsFor: 'examples' stamp: 'StefanReichhart 9/6/2015 17:16'!
gtExampleEmpty
	<gtExample>
	<label: 'Empty'>
	
	^ self new! !

!GTPlayBook class methodsFor: 'initializing' stamp: 'StefanReichhart 3/22/2015 13:43'!
initialize
	" we have to make sure the cached references are up-to-date after the image starts up "
	
	Smalltalk addToStartUpList: self! !

GTPlayBook initialize!

!GTPlayBook class methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:48'!
instance
	^ instance ifNil: [ instance := self new ]! !

!GTPlayBook class methodsFor: 'private' stamp: 'TudorGirba 10/19/2014 21:34'!
reset
	
	instance := nil! !

!GTPlayBook class methodsFor: 'private' stamp: 'TudorGirba 4/7/2015 23:04'!
resetDirectories

	cacheDirectory := nil! !

!GTPlayBook class methodsFor: 'initializing' stamp: 'StefanReichhart 3/22/2015 13:43'!
startUp

	cacheDirectory := nil.! !

!GTPlayBook class methodsFor: 'initializing' stamp: 'StefanReichhart 3/22/2015 13:43'!
startUp: resuming

	cacheDirectory := nil.! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'AndreiChis 11/10/2015 17:19'!
stashDirectory
	" lazy initialize the stash and always ensure its existence - especially while the image is running "
	(stashDirectory notNil and: [ stashDirectory exists ])
		ifFalse: [ stashDirectory := self defaultStashDirectory ].
	^ stashDirectory ensureCreateDirectory! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 23:17'!
stashDirectory: aStringOrFileReference

	stashDirectory := self 
							ensureDirectory: aStringOrFileReference 
							distinctFrom: self defaultStashDirectory! !

!GTPlayBook methodsFor: 'actions' stamp: 'StefanReichhart 3/21/2015 09:37'!
addPage: aPage
	self pages addFirst: aPage! !

!GTPlayBook methodsFor: 'actions' stamp: 'StefanReichhart 3/20/2015 22:48'!
addPageIfInteresting: aPage
	aPage isInteresting ifFalse: [ ^ self ].
	self addPage: aPage! !

!GTPlayBook methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/20/2015 22:40'!
allFiles
	^ self class cacheDirectory files select: [ :each | 
		each extension = GTPlayPage fileExtension ]! !

!GTPlayBook methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/21/2015 09:38'!
allFilesSorted
	^ self allFiles sorted: [ :a :b | 
		a modificationTime > b modificationTime ]! !

!GTPlayBook methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/20/2015 22:45'!
defaultPages
	^ OrderedCollection new! !

!GTPlayBook methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/21/2015 09:47'!
defaultPagesLimit
	" page list in ui might get too long / holding too many object might decrease performance "
	^ 100! !

!GTPlayBook methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/21/2015 09:36'!
files
	^ self allFilesSorted takeFirst: self pagesLimit! !

!GTPlayBook methodsFor: 'ui' stamp: 'StefanReichhart 3/21/2015 09:39'!
gtPagesIn: composite
	<gtInspectorPresentationOrder: 0>
	composite list 
		title: 'Pages';
		display: [ self pages ];
		format: #gtDisplayString;
		filterOn: [ :text :each | text match: each content ]! !

!GTPlayBook methodsFor: 'initializing' stamp: 'StefanReichhart 3/21/2015 09:36'!
initialize
	self flag: 'error handling'.
	
	self pages: self defaultPages.
	self files do: [ :each | 
		[ self pages add: (GTPlayPage fromFileReference: each) ] " bypass "
			on: Error 
			do: [ " unhandled exceptions are bad design - we should handle it somehow " ] ]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 22:45'!
pages
	^ pages ifNil: [ pages := self defaultPages ]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:49'!
pages: anObject
	pages := anObject! !

!GTPlayBook methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 22:34'!
pagesLimit
	^ pagesLimit ifNil: [ self defaultPagesLimit ]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 22:33'!
pagesLimit: anObject
	pagesLimit := anObject! !

!GTPlayBook methodsFor: 'actions' stamp: 'StefanReichhart 3/21/2015 09:48'!
removePage: aPage
	self pages remove: aPage ifAbsent: [ " ignore if aPage is not registered " ]! !

Object subclass: #GTPlayPage
	instanceVariableNames: 'title content creationTime modificationTime publishedUrl persistenceStrategies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayPage commentStamp: 'TudorGirba 10/22/2014 07:52' prior: 0!
It holds one page of code. It is the model behind the Playground.

It also knows how to store itself on disk, and every time its content changes, it updates the corresponding file.!

!GTPlayPage class methodsFor: 'private' stamp: 'TudorGirba 4/7/2015 22:27'!
basicLoadFromPublishUrl: aString
	^ GTPlayPage new 
		saveContent: (GTUrlProvider new get: aString)
		yourself! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'StefanReichhart 3/20/2015 23:43'!
creationTimeFrom: aFileReference
	^ [ self creationTimeFromString: aFileReference basenameWithoutExtension ] 
		on: Error 
		do: [ aFileReference creationTime ]! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'StefanReichhart 3/21/2015 09:50'!
creationTimeFromString: aString
	" this is really ugly, but hopefully only a temporary solution untill we come up with somthing more reliable and more beautiful "
	| subexpressions |
	subexpressions := OrderedCollection new.
	'(\d+)-(\d+)-(\d+)T(\d+)-(\d+)-(\d+)(-(\d+))?([-+]\d+)-(\d+)(-(\d+))?' asRegex 
		matchesIn: aString
		subexpressionsDo: [ :expression :expressionFragments | 
			subexpressions addAll: (expressionFragments collect: [ :each | 
				[ each squeezeOutNumber ] on: Error do: [ 0 ] ]) ].
	^ DateAndTime 
		year: subexpressions first 
		month: subexpressions second 
		day: subexpressions third 
		hour: subexpressions fourth 
		minute: subexpressions fifth 
		second: subexpressions sixth 
		nanoSecond: subexpressions eighth * 100000 " 7 == full match "
		offset: (Duration 
						days: 0 
						hours: subexpressions ninth 
						minutes: (subexpressions at: 10) 
						seconds: (subexpressions at: 12)) " 11 == full match "! !

!GTPlayPage class methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/20/2015 22:31'!
fileExtension
	^ 'ph'! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'TudorGirba 4/7/2015 22:23'!
fromFileReference: aFileReference
	^ self new
		content: (aFileReference readStreamDo: #contents); 
		creationTime: (self creationTimeFrom: aFileReference);
		yourself! !

!GTPlayPage class methodsFor: 'examples' stamp: 'StefanReichhart 9/6/2015 17:16'!
gtExampleEmpty
	<gtExample>
	<label: 'Empty'>
	
	^ self new! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'StefanReichhart 3/20/2015 18:58'!
loadFromPublishUrl: aString
	^ [ self basicLoadFromPublishUrl: aString ] 
		on: Error 
		do: [ nil ]! !

!GTPlayPage class methodsFor: 'instance creation' stamp: 'StefanReichhart 3/20/2015 18:59'!
loadFromPublishUrl: aString thenDo: aBlock
	| page |
	page := self loadFromPublishUrl: aString.
	page ifNotNil: [ aBlock value: page ].
	^ page! !

!GTPlayPage methodsFor: 'compatibility-tools' stamp: 'StefanReichhart 3/21/2015 09:45'!
acceptContents: aStringOrtext

	self flag: #TODO. "Need support for what lies in the comment down here"
	"self fileName ifNotNil: [ self saveString: aStringOrtext toFile: self fileName ].

	acceptAction ifNotNil:[acceptAction value: aStringOrtext]."
	self saveContent: aStringOrtext.
	^ true! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 22:28'!
content
	^ content! !

!GTPlayPage methodsFor: 'accessing' stamp: 'PavelKrivanek 1/31/2017 11:49'!
content: aString
	content := aString asString! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/21/2015 09:46'!
contentString
	" strange, sometimes #content is aText not aString !! "
	^ self content asString! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 22:27'!
creationTime
	^ creationTime! !

!GTPlayPage methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 21:49'!
creationTime: anObject
	creationTime := anObject! !

!GTPlayPage methodsFor: 'accessing-defaults' stamp: 'TudorGirba 4/7/2015 22:29'!
creationTimeForFileName
	^ (self creationTime asString copyReplaceAll: ':' with: '-') copyReplaceAll: '.' with: '-'! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'TudorGirba 4/8/2015 22:22'!
ensureStashPersistency
	(self persistenceStrategies noneSatisfy: [ :each | each isStash ])
		ifTrue: [ self persistenceStrategies add: (GTPlayPageStashPersistence new page: self) ]! !

!GTPlayPage methodsFor: 'ui' stamp: 'StefanReichhart 3/21/2015 09:44'!
gtDisplayOn: stream
	stream nextPutAll: (self contentString copyReplaceAll: String cr with: String space)! !

!GTPlayPage methodsFor: 'ui' stamp: 'AndreiChis 10/23/2015 17:16'!
gtInspectorContentIn: composite
	<gtInspectorPresentationOrder: 0>
	composite pharoScript 
		title: 'Content';
		display: #content;
		installDefaultSelectionActions! !

!GTPlayPage methodsFor: 'initializing' stamp: 'TudorGirba 4/9/2015 11:36'!
initialize
	super initialize.
	self content: ''.
	self creationTime: DateAndTime now.
	title := nil.
	persistenceStrategies := OrderedCollection with: (GTPlayPageCachePersistence new page: self)! !

!GTPlayPage methodsFor: 'testing' stamp: 'StefanReichhart 3/21/2015 09:44'!
isInteresting
	^ self contentString trimBoth isEmpty not! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 17:22'!
persistenceStrategies
	^ persistenceStrategies! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 17:22'!
persistenceStrategies: anObject
	persistenceStrategies := anObject! !

!GTPlayPage methodsFor: 'actions' stamp: 'StefanReichhart 3/22/2015 21:28'!
publish
	(self confirm: 'Publish playground content to the cloud?')
        ifFalse: [ ^ self ].
    self content ifEmpty: [ 
        self inform: 'Nothing was published because the playground is empty'.
        ^ self ].
    Clipboard clipboardText: (publishedUrl := (GTUrlProvider new post: self contentString) asString).
    self inform: publishedUrl , ' was published and the url was copied to clipboard'! !

!GTPlayPage methodsFor: 'actions' stamp: 'TudorGirba 4/4/2015 23:15'!
save
	persistenceStrategies do: [ :each | each save ]! !

!GTPlayPage methodsFor: 'actions' stamp: 'TudorGirba 4/7/2015 22:24'!
saveContent: aStringOrText
	self content: aStringOrText.
	self save.! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'TudorGirba 4/9/2015 11:38'!
setTitleAndEnsureInStash: aString
	self title: aString.
	self ensureStashPersistency.
	self save! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'TudorGirba 4/9/2015 11:36'!
title
	^ title ifNil: [ 'Page' ]! !

!GTPlayPage methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 3/25/2015 16:49'!
title: aString
	title := aString! !

Object subclass: #GTPlayPagePersistence
	instanceVariableNames: 'page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTPlayPagePersistence subclass: #GTPlayPageFilePersistence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTPlayPageFilePersistence subclass: #GTPlayPageCachePersistence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayPageCachePersistence methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 17:24'!
fileDirectory
	^ GTPlayBook cacheDirectory! !

!GTPlayPageCachePersistence methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 22:31'!
fileName
	^ self page creationTimeForFileName, '.' , GTPlayPage fileExtension! !

!GTPlayPageFilePersistence methodsFor: 'private' stamp: 'TudorGirba 4/4/2015 23:41'!
deleteFromFileSystem
	self fileReference ensureDelete! !

!GTPlayPageFilePersistence methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2015 23:49'!
fileDirectory
	^ self subclassResponsibility ! !

!GTPlayPageFilePersistence methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 22:20'!
fileName
	self subclassResponsibility! !

!GTPlayPageFilePersistence methodsFor: 'accessing-dynamic' stamp: 'TudorGirba 4/4/2015 23:11'!
fileReference
	^ self fileDirectory / self fileName! !

!GTPlayPageFilePersistence methodsFor: 'actions' stamp: 'TudorGirba 4/4/2015 23:42'!
save
	self page content isEmpty
		ifTrue: [ self deleteFromFileSystem ]
		ifFalse: [ self writeToFileSystem ]! !

!GTPlayPageFilePersistence methodsFor: 'private' stamp: 'TudorGirba 4/4/2015 23:47'!
writeToFileSystem
	self fileReference writeStreamDo: [ :stream | 
		stream 
			truncate; 
			nextPutAll: self page contentString ]! !

GTPlayPageFilePersistence subclass: #GTPlayPageStashPersistence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayPageStashPersistence methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 23:18'!
fileDirectory
	^ GTPlayBook stashDirectory! !

!GTPlayPageStashPersistence methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2015 22:31'!
fileName
	^ self page title, '-', self page creationTimeForFileName, '.', GTPlayPage fileExtension! !

!GTPlayPageStashPersistence methodsFor: 'testing' stamp: 'TudorGirba 4/8/2015 22:18'!
isStash
	^ true! !

!GTPlayPagePersistence methodsFor: 'testing' stamp: 'TudorGirba 4/8/2015 22:18'!
isStash
	^ false! !

!GTPlayPagePersistence methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2015 23:13'!
page
	^ page! !

!GTPlayPagePersistence methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2015 23:13'!
page: anObject
	page := anObject! !

Object subclass: #GTUrlProvider
	instanceVariableNames: 'urlProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTUrlProvider class
	instanceVariableNames: 'urlProvider'!

!GTUrlProvider commentStamp: 'TudorGirba 10/22/2014 07:50' prior: 0!
This class was inspired from the Zinc SharedWorkspace project.

Its job is to work with a UrlProvider that can provide (via get) and store (via post) strings.!

GTUrlProvider class
	instanceVariableNames: 'urlProvider'!

!GTUrlProvider class methodsFor: 'settings' stamp: 'StephaneDucasse 11/3/2016 21:14'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #stringUrlProvider)
		parent: #gt;
		target: self;
		description: 'The url for the script sharing service like the one from http://ws.stfx.eu';
		label: 'The url for the script sharing service'
! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 08:02'!
stringUrlProvider
	^ self urlProvider asString! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 08:01'!
stringUrlProvider: aString
	self urlProvider: aString! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 07:48'!
urlProvider
	^ urlProvider ifNil: [ urlProvider := 'http://ws.stfx.eu' asZnUrl ]! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 07:48'!
urlProvider: aUrlObject
	urlProvider := aUrlObject ifNotNil: [ aUrlObject asZnUrl ]! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:50'!
get: url	
	| contents |
	contents := self httpClient get: url.
	^ String new: contents size streamContents: [ :stream |
		contents linesDo: [ :each | stream nextPutAll: each; cr ] ]! !

!GTUrlProvider methodsFor: 'private' stamp: 'TudorGirba 10/22/2014 07:47'!
httpClient
	^ ZnClient new
		systemPolicy;
		beOneShot;
		accept: ZnMimeType textPlain;
		url: self urlProvider;
		yourself! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:53'!
post: string
	| entity client url |
	entity := ZnEntity text: string asString.
	(client := self httpClient)
		entity: entity; 
		post.
	url := client response location.
	^ url asZnUrl inContextOf: self urlProvider ! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:49'!
urlProvider
	^ urlProvider ifNil: [ urlProvider := self class urlProvider ]! !

!GTUrlProvider methodsFor: 'initialize-release' stamp: 'TudorGirba 10/22/2014 07:49'!
urlProvider: anUrlObject
	urlProvider := anUrlObject asZnUrl ! !

GTPlayBook initialize!
